
@ v1.2

@ This file has no copyright assigned and is placed in the Public Domain.
@ You are free to use this source code without limitation.
@
@ This software is distributed WITHOUT ANY WARRANTY. 
@ ALL WARRANTIES, EXPRESSED OR IMPLIED ARE HEREBY DISCLAIMED.
@ This includes but is not limited to warranties
@ of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

@.EQU JUST_VRAM_PLEASE, 1
@.EQU MINIMAL_CODE, 1

.INCLUDE "lzss_d.h"

.SECTION .iwram,"ax",%progbits
.ARM
.ALIGN

.IFNDEF MINIMAL_CODE

@==============================================================================

LZ77UnCompWRAM:

.IFNDEF JUST_VRAM_PLEASE

  stmfd   r13!, {r4-r7}
  add     r0, r0, #1
  ldrb    r2, [r0], #1
  mov     r3, r2
  ldrb    r2, [r0], #1
  orr     r3, r3, r2, lsl #8
  ldrb    r2, [r0], #1
  orrs    r3, r3, r2, lsl #16
  beq     get_out_WRAM
  add     r3, r3, r1
  mov     r2, #1
  orr     r2, r2, r2, lsl #8
  orr     r2, r2, r2, lsl #16
1:  
  movs    r2, r2, ror #1
  ldrcsb  r4, [r0], #1
  ldrb    r5, [r0], #1
  tst     r4, r2
  beq     no_comp_WRAM
  add     r7, r5, #0x20
  ldrb    r6, [r0], #1
  and     r5, r5, #0x0F
  orr     r5, r6, r5, lsl #8
  add     r5, r5, #1
2:
  ldrb    r6, [r1, -r5]
  strb    r6, [r1], #1
  subs    r7, r7, #0x10
  bge     2b
  cmp     r1, r3
  blo     1b
  
get_out_WRAM:  
  ldmfd   r13!, {r4-r7}
  bx      r14

@------------------------------------------------------------------------------

@ Subroutines

no_comp_WRAM:
  strb    r5, [r1], #1
  cmp     r1, r3
  blo     1b
  b       get_out_WRAM

@==============================================================================
.ENDIF @ ! JUST_VRAM_PLEASE

LZ77UnCompVRAM:

  stmfd   r13!, {r4-r9}
  add     r0, r0, #1
  ldrb    r2, [r0], #1
  mov     r3, r2
  ldrb    r2, [r0], #1
  orr     r3, r3, r2, lsl #8
  ldrb    r2, [r0], #1
  orrs    r3, r3, r2, lsl #16
  beq     get_out_VRAM
  add     r3, r3, r1
  mov     r2, #1
  orr     r2, r2, r2, lsl #8
  orr     r2, r2, r2, lsl #16
  tst     r1, #1
  ldrneh  r8, [r1, #-1]
  andne   r8, r8, #0xFF
  tst     r3, #1
  ldrneh  r9, [r3, #-1]
  andne   r9, r9, #0xFF00

1:  
  movs    r2, r2, ror #1
  ldrcsb  r4, [r0], #1
  ldrb    r5, [r0], #1
  tst     r4, r2
  beq     no_comp_VRAM
  add     r7, r5, #0x20
  ldrb    r6, [r0], #1
  and     r5, r5, #0x0F
  orrs    r5, r6, r5, lsl #8
  beq     offset_0_case
  add     r5, r5, #1
  
2:
  tst     r1, #1
  ldrb    r6, [r1, -r5]
  moveq   r8, r6
  addeq   r1, r1, #1
  orrne   r8, r8, r6, lsl #8
  strneh  r8, [r1], #1
  subs    r7, r7, #0x10
  bge     2b
3:  
  cmp     r1, r3
  blo     1b
  
aft_loop_cmp_VRAM:
  tst     r1, #1
  orrne   r8, r8, r9
  strneh  r8, [r1]
    
get_out_VRAM:  
  ldmfd   r13!, {r4-r9}
  bx      r14

@------------------------------------------------------------------------------

@ Subroutines

no_comp_VRAM:
  tst     r1, #1
  moveq   r8, r5
  addeq   r1, r1, #1
  orrne   r8, r8, r5, lsl #8
  strneh  r8, [r1], #1
  cmp     r1, r3
  blo     1b
  b       aft_loop_cmp_VRAM
  
offset_0_case:  
  tst     r1, #1
  ldreqb  r8, [r1, #-1]
  addeq   r1, r1, #1
  orrne   r8, r8, r8, lsl #8
  strneh  r8, [r1], #1
  subs    r7, r7, #0x10
  blt     3b
same_char_loop:  
  tst     r1, #1
  moveq   r8, r8, lsr #8
  addeq   r1, r1, #1
  orrne   r8, r8, r8, lsl #8
  strneh  r8, [r1], #1
  subs    r7, r7, #0x10
  bge     same_char_loop
  cmp     r1, r3
  blo     1b
  b       aft_loop_cmp_VRAM
  
@==============================================================================

.ELSE @ MINIMAL_CODE

LZ77UnCompWRAM:
LZ77UnCompVRAM:
  stmfd   r13!, {r4-r9}
  add     r0, r0, #1
  ldrb    r2, [r0], #1
  mov     r3, r2
  ldrb    r2, [r0], #1
  orr     r3, r3, r2, lsl #8
  ldrb    r2, [r0], #1
  orrs    r3, r3, r2, lsl #16
  beq     get_out_VRAM
  add     r3, r3, r1
  mov     r2, #1
  orr     r2, r2, r2, lsl #8
  orr     r2, r2, r2, lsl #16
  tst     r1, #1
  ldrneh  r8, [r1, #-1]
  andne   r8, r8, #0xFF
  tst     r3, #1
  ldrneh  r9, [r3, #-1]
  andne   r9, r9, #0xFF00

1:  
  movs    r2, r2, ror #1
  ldrcsb  r4, [r0], #1
  ldrb    r5, [r0], #1
  tst     r4, r2
  beq     no_comp_VRAM
  add     r7, r5, #0x20
  ldrb    r6, [r0], #1
  and     r5, r5, #0x0F
  orr     r5, r6, r5, lsl #8
  add     r5, r5, #1  

2:
  ldrb    r6, [r1, -r5]
  tst     r1, #1
  moveq   r8, r6
  orrne   r8, r8, r6, lsl #8
  strh    r8, [r1], #1
  subs    r7, r7, #0x10
  bge     2b
  cmp     r1, r3
  blo     1b
  
aft_loop_cmp_VRAM:
  tst     r1, #1
  orrne   r8, r8, r9
  strneh  r8, [r1]
    
get_out_VRAM:  
  ldmfd   r13!, {r4-r9}
  bx      r14

@------------------------------------------------------------------------------

@ Subroutines

no_comp_VRAM:
  tst     r1, #1
  moveq   r8, r5
  orrne   r8, r8, r5, lsl #8
  strh    r8, [r1], #1
  cmp     r1, r3
  blo     1b
  b       aft_loop_cmp_VRAM

.ENDIF @ ! MINIMAL_CODE

@==============================================================================

.POOL

.END

